package com.thebrokenrail.scriptcraft.api.bridge;

import com.thebrokenrail.scriptcraft.core.ScriptCraftCore;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.inventory.Inventory;
import net.minecraft.util.registry.Registry;

import java.util.Objects;

class BlockEntityBridges {
    static void register() {
        ScriptCraftCore.addBridge("BlockEntity.getID", args -> Objects.requireNonNull(Registry.BLOCK_ENTITY_TYPE.getId(((BlockEntity) args[0]).getType())).toString());
        ScriptCraftCore.addBridge("BlockEntity.getInventory", args -> {
            BlockEntity entity = (BlockEntity) args[0];
            if (entity instanceof Inventory) {
                return entity;
            } else {
                return null;
            }
        });
        ScriptCraftCore.addBridge("BlockEntity.markDirty", args -> {
            ((BlockEntity) args[0]).markDirty();
            return null;
        });
    }
}
